'use strict';

var isNode = require('detect-node');
var Connection = require('interface-connection').Connection;
var contains = require('lodash.contains');

// const IPFS_CODE = 421

var createServer = void 0;

if (isNode) {
  createServer = require('pull-ws/server');
} else {
  createServer = function createServer() {};
}

module.exports = function (options, handler) {
  var listener = createServer(function (socket) {
    socket.getObservedAddrs = function (cb) {
      // TODO research if we can reuse the address in anyway
      return cb(null, []);
    };

    handler(new Connection(socket));
  });

  var listeningMultiaddr = void 0;

  listener._listen = listener.listen;
  listener.listen = function (ma, cb) {
    cb = cb || function () {};
    listeningMultiaddr = ma;

    if (contains(ma.protoNames(), 'ipfs')) {
      ma = ma.decapsulate('ipfs');
    }

    listener._listen(ma.toOptions(), cb);
  };

  listener.getAddrs = function (cb) {
    cb(null, [listeningMultiaddr]);
  };

  return listener;
};